Index: funcs/func_logic.c
===================================================================
RCS file: /usr/cvsroot/asterisk/funcs/func_logic.c,v
retrieving revision 1.3
diff -u -u -r1.3 func_logic.c
--- funcs/func_logic.c	17 May 2005 16:45:42 -0000	1.3
+++ funcs/func_logic.c	19 May 2005 19:28:11 -0000
@@ -72,6 +72,59 @@
 	return ret;
 }
 
+static char *builtin_function_let(struct ast_channel *chan, char *cmd, char *data, char *buf, size_t len) 
+{
+	char *ret = NULL, *varname, *func;
+
+	if ((varname = ast_strdupa(data))) {
+		if ((func = strchr(varname, '='))) {
+			char workspace[1024];
+
+			*func = '\0';
+			func++;
+			varname = ast_strip(varname);
+			func = ast_strip(func);
+			if ((ret = ast_func_read(chan, func, workspace, sizeof(workspace)))) {
+				pbx_builtin_setvar_helper(chan, varname, ret);
+				ast_copy_string(buf, ret, len);
+				ret = buf;
+			}
+			
+		} else {
+			ast_log(LOG_WARNING, "Syntax Error!\n");
+		}
+		
+	} else {
+        ast_log(LOG_WARNING, "Memory Error!\n");
+    }
+
+	return ret;
+}
+
+
+static char *builtin_function_set(struct ast_channel *chan, char *cmd, char *data, char *buf, size_t len) 
+{
+	char *ret = NULL, *varname, *val;
+
+	if ((varname = ast_strdupa(data))) {
+		if ((val = strchr(varname, '='))) {
+			*val = '\0';
+			val++;
+			varname = ast_strip(varname);
+			val = ast_strip(val);
+			pbx_builtin_setvar_helper(chan, varname, val);
+			ast_copy_string(buf, val, len);
+		} else {
+			ast_log(LOG_WARNING, "Syntax Error!\n");
+		}
+		
+	} else {
+        ast_log(LOG_WARNING, "Memory Error!\n");
+    }
+
+	return ret;
+}
+
 #ifndef BUILTIN_FUNC
 static
 #endif
@@ -80,6 +133,26 @@
 	.synopsis = "NULL Test: Returns 1 if NULL or 0 otherwise",
 	.syntax = "ISNULL(<data>)",
 	.read = builtin_function_isnull,
+};
+
+#ifndef BUILTIN_FUNC
+static
+#endif
+struct ast_custom_function let_function = {
+	.name = "LET",
+	.synopsis = "LET assigns a value to a function call.",
+	.syntax = "LET(<varname>=<FUNC(args)>)",
+	.read = builtin_function_let,
+};
+
+#ifndef BUILTIN_FUNC
+static
+#endif
+struct ast_custom_function set_function = {
+	.name = "SET",
+	.synopsis = "SET assigns a value to a function call.",
+	.syntax = "SET(<varname>=<value>)",
+	.read = builtin_function_set,
 };
 
 #ifndef BUILTIN_FUNC
